unit MyDownload_Setup_Sys;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, ExtCtrls, FileCtrl, Registry, ShlObj, ShellApi;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    RadioGroup1: TRadioGroup;
    Memo1: TMemo;
    GroupBox1: TGroupBox;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    OpenDialog1: TOpenDialog;
    TabSheet3: TTabSheet;
    Memo2: TMemo;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure DoPreNex;
    procedure PathBtnClick(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure DoAction(Install: Boolean);
    procedure DoRegisterDLL(Path, Param: String);
    procedure TabSheet3Show(Sender: TObject);
    procedure TabSheet2Show(Sender: TObject);
    procedure AllEditChange(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;
  UserMode: Boolean = True;

const ExtMyDownload = '\Software\Microsoft\Internet Explorer\MenuExt\&My Download';
      EXE = 'MyDownload.exe';
      DLL = 'MyDownload_ComHost.dll';

function CloseIE(Handle: HWND; LParam: LParam): Boolean; stdcall;

implementation

uses MyDownload_CommonConsts;

{$R *.dfm}

function ExtractIndex(Component: TComponent): String;
var I: Integer;
begin
with Component do
  begin
  for I:=0 to Length(Name) - 1 do
    if Name[I] in ['0'..'9'] then
      Break;
  Result:=Copy(Name, I, Length(Name));
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var MsgFile: String;
begin
if (PageControl1.ActivePageIndex = 1) then
  begin
  MsgFile:='Ce(s) fichier(s) n''existent pas :';
  if (not FileExists(IncludeTrailingPathDelimiter(Edit4.Text) + EXE)) and (Edit4.Enabled) then
    MsgFile:=MsgFile + sLineBreak + '- Application rsidente : ' + IncludeTrailingPathDelimiter(Edit4.Text) + EXE;
  if not FileExists(IncludeTrailingPathDelimiter(Edit5.Text) + DLL) then
    MsgFile:=MsgFile + sLineBreak + '- Serveur COM : ' + IncludeTrailingPathDelimiter(Edit5.Text) + DLL;
  if (Edit4.Enabled) and (not (FileExists(Edit6.Text) and (ExtractFileExt(Edit6.Text) = '.htm') and (Pos('Download', ExtractFileName(Edit6.Text)) = 1))) then
    MsgFile:=MsgFile + sLineBreak + '- Script : ' + Edit6.Text;
  if Pos('-', MsgFile) <> 0 then
    begin
    MessageDlg(MsgFile, mtError, [mbOk], 0);
    Exit;
    end;
  end;
with PageControl1 do
  ActivePageIndex:=ActivePageIndex + 1;
DoPreNex;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
with PageControl1 do
  ActivePageIndex:=ActivePageIndex - 1;
DoPreNex;
end;

procedure TForm1.DoPreNex;
begin
with PageControl1 do
  begin
  Button1.Enabled:=(ActivePageIndex <> 0) and (ActivePageIndex <> PageCount - 1);
  Button2.Enabled:=ActivePageIndex <> PageCount - 1;
  Button2.Default:=Button2.Enabled;
  Button3.Default:=not Button2.Default;
  if ActivePageIndex = 1 then
    Button2.Enabled:=False;
  if ActivePageIndex = PageCount - 1 then
    Button3.Caption:='Terminer'
  else
    Button3.Caption:='Fermer'
  end;
end;

procedure TForm1.PathBtnClick(Sender: TObject);
var Path: String;
begin
UserMode:=False;
if SelectDirectory('Slectionner le dossier d''installation (' +
                    (FindComponent('Label'+ExtractIndex((Sender as TComponent))) as TLabel).Caption +
                    ') :', '', Path) then
  begin
  (FindComponent('Edit'+ExtractIndex((Sender as TComponent))) as TEdit).Text:=Path;
  end;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
with OpenDialog1 do
  if (Execute) then
    Edit6.Text:=OpenDialog1.FileName;
end;

function CloseIE(Handle: HWND; LParam: LParam): Boolean;
var ClassName: array[0..250] of Char;
begin
GetClassName(Handle, ClassName, SizeOf(ClassName));
if ClassName = 'IEFrame' then
  PostMessage(Handle, WM_CLOSE, 0, 0);
Result:=True;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
if Button3.Caption = 'Terminer' then
  begin
  if (FindWindow('IEFrame', nil) <> 0) and (MessageDlg('Pour que l''exemple soit ' +
     'appliqu, il faut que toutes les fentres d''Internet Explorer soit fermes.' +
     sLineBreak + 'Voulez-vous les fermer automatiquement ?', mtConfirmation, [mbYes, mbNo], 0) =  mrYes) then
    begin
    EnumWindows(@CloseIE, 0);
    end;
  Close;
  end
else if MessageDlg('L''installation ou la dsinstallation n''est pas termine.' + sLineBreak +
    'Voulez-vous quitter ?', mtConfirmation, [mbYes, mbNo], 0) =  mrYes then
  Close;
end;

procedure TForm1.DoAction(Install: Boolean);
var Registry: TRegistry;
begin
try
  Registry:=TRegistry.Create;
  with Registry do
    if Install then
      begin
      OpenKey(ExtMyDownload, True);
      WriteString('', Edit6.Text);
      WriteInteger('Contexts', $20);
      RootKey:=HKEY_LOCAL_MACHINE;
      OpenKey('\Software\' + HostPathKey, True);
      WriteString('', IncludeTrailingPathDelimiter(Edit4.Text) + EXE);
      DoRegisterDLL(IncludeTrailingPathDelimiter(Edit5.Text) + DLL, '');
      end
    else
      begin
      DeleteKey(ExtMyDownload);
      RootKey:=HKEY_LOCAL_MACHINE;
      DeleteKey('\Software\' + HostPathKey);
      DoRegisterDLL(IncludeTrailingPathDelimiter(Edit5.Text) + DLL, '/u');
      end;
finally
  FreeAndNil(Registry); 
end;
end;

procedure TForm1.DoRegisterDLL(Path, Param: String);
begin
ShellExecute(Handle, 'Open', 'regsvr32', PChar(Param + ' /s "' + Path + '"'), nil, SW_HIDE);
end;

procedure TForm1.TabSheet3Show(Sender: TObject);
begin
DoAction(RadioGroup1.ItemIndex = 0);
end;

procedure TForm1.TabSheet2Show(Sender: TObject);
begin
Edit4.Enabled:=RadioGroup1.ItemIndex = 0;
Edit6.Enabled:=RadioGroup1.ItemIndex = 0;
Button4.Enabled:=RadioGroup1.ItemIndex = 0;
Button6.Enabled:=RadioGroup1.ItemIndex = 0;
end;

procedure TForm1.AllEditChange(Sender: TObject);
begin
Button2.Enabled:=((Edit4.GetTextLen <> 0) or (not Edit4.Enabled)) and
                 (Edit5.GetTextLen <> 0) and
                 ((Edit6.GetTextLen <> 0) or (not Edit6.Enabled));
end;

end.
